VERSION:
3.001

// This define will make sure that we will use RTDS specific
// versions of the common code in cb.c
#define RTDS

// Include file below is generated by C-Builder
// and contains the variables declared as -
// PARAMETERS, INPUTS, OUTPUTS . . .
#include "ebm_v2.h"
#include "ebm_config.h"

STATIC:

// -----------------------------------------------
// Variables declared here may be used in both the
// RAM: and CODE: sections below.
// -----------------------------------------------
double dt;

int _seqno_local;
int seqno_offset;
int has_seqno_offset;
double prev_p[NPHASES];
double e_gen[NPHASES];
double e_con[NPHASES];
int cb_pos[CB_BUFFERS*NPHASES];
double cb_buffer[CB_BUFFERS*NPHASES][CB_DEPTH];

// - E n d   o f   S T A T I C :   S e c t i o n -

RAM_FUNCTIONS:

#include "cb.c"
#include "ebm_wrapper.c"

// -----------------------------------------------
// This section should contain any 'c' functions
// to be called from the RAM section (either
// RAM_PASS1 or RAM_PASS2). Example:
//
// static double myFunction(double v1, double v2)
// {
//     return(v1*v2);
// }
// -----------------------------------------------

RAM:

struct ebm_states s;
int n, p;

/* Load buffers */
p = 0;

for (n = 0; n < NPHASES; n++) {
#ifdef WITH_SIGNAL_RESIDUALS
	s.cb_v_local[n]		= cb_load(p++);
	s.cb_i_local[n]		= cb_load(p++);
#endif
	s.cb_e_gen_local[n]	= cb_load(p++);
	s.cb_e_con_local[n]	= cb_load(p++);
	s.cb_e_gen_remote[n]	= cb_load(p++);
	s.cb_e_con_remote[n]	= cb_load(p++);
	s.cb_e_if_active[n]	= cb_load(p++);
	s.cb_e_if_passive[n]	= cb_load(p++);
#ifdef WITH_SIGNAL_ERRORS
	s.cb_v_orgn[n]		= cb_load(p++);
	s.cb_i_orgn[n]		= cb_load(p++);
#endif
}

/* Load State */
s.seqno_local = _seqno_local;
s.seqno_offset = seqno_offset;
s.has_seqno_offset = has_seqno_offset;

s.prev_p = prev_p;
s.e_gen = e_gen;
s.e_con = e_con;

ebm_init(&s);

/* Save State */
_seqno_local = s.seqno_local;
seqno_offset = s.seqno_offset;
has_seqno_offset = s.has_seqno_offset;

/* Save buffers */
p = 0;

for (n = 0; n < NPHASES; n++) {
#ifdef WITH_SIGNAL_RESIDUALS
	cb_store(&s.cb_v_local[n], p++);
	cb_store(&s.cb_i_local[n], p++);
#endif
	cb_store(&s.cb_e_gen_local[n], p++);
	cb_store(&s.cb_e_con_local[n], p++);
	cb_store(&s.cb_e_gen_remote[n], p++);
	cb_store(&s.cb_e_con_remote[n], p++);
	cb_store(&s.cb_e_if_active[n], p++);
	cb_store(&s.cb_e_if_passive[n], p++);
#ifdef WITH_SIGNAL_ERRORS
	cb_store(&s.cb_v_orgn[n], p++);
	cb_store(&s.cb_i_orgn[n], p++);
#endif
}


// -----------------------------------------------
// Place C code here which computes constants
// required for the CODE: section below.  The C
// code here is executed once, prior to the start
// of the simulation case.
// -----------------------------------------------
dt = getTimeStep();

// ------------- End of RAM: Section -------------

CODE_FUNCTIONS:

#include "cb.c"
#include "ebm_wrapper.c"

CODE:

// -----------------------------------------------
// Place C code here which runs on the RTDS. The
// code below is entered once each simulation
// step.
// -----------------------------------------------

struct ebm_inputs i;
struct ebm_outputs o;
struct ebm_states s;

int n, p;

/* Load Inputs */
i.recv_ready		= recv_ready;
i.sec_local		= sec_local;
i.nsec_local		= nsec_local;
i.sec_remote		= sec_remote;
i.nsec_remote		= nsec_remote;
i.seqno_remote		= seqno_remote;
i.v_local		= &v_local;
i.i_local		= &i_local;
#if defined(WITH_SIGNAL_RESIDUALS) || defined(WITH_SIGNAL_ERRORS)
i.v_remote		= &v_remote;
i.i_remote		= &i_remote;
#endif
i.e_gen_remote		= &e_gen_remote;
i.e_con_remote		= &e_con_remote;
#ifdef WITH_SIGNAL_ERRORS
i.v_orgn = &v_orgn;
i.i_orgn = &i_orgn;
#endif

/* Load outputs */
o.scopes		= &scopes;
o.p_local		= &p_local;
o.p_remote		= &p_remote;
#ifdef WITH_SIGNAL_RESIDUALS
o.res_v			= &res_v;
o.res_i			= &res_i;
o.res_p			= &res_p;
#endif
o.res_e_cp_active	= &res_e_cp_active;
o.res_e_cp_passive	= &res_e_cp_passive;
o.res_e_ow_active	= &res_e_ow_active;
o.res_e_ow_passive	= &res_e_ow_passive;
o.res_e_active		= &res_e_active;
o.res_e_passive		= &res_e_passive;
o.e_gen_local		= &e_gen_local;
o.e_con_local		= &e_con_local;
#ifdef WITH_SIGNAL_ERRORS
o.err_v_local		= &err_v_local;
o.err_v_remote		= &err_v_remote;
o.err_i_local		= &err_i_local;
o.err_i_remote		= &err_i_remote;
#endif

/* Load buffers */
p = 0;

for (n = 0; n < NPHASES; n++) {
#ifdef WITH_SIGNAL_RESIDUALS
	s.cb_v_local[n]		= cb_load(p++);
	s.cb_i_local[n]		= cb_load(p++);
#endif
	s.cb_e_gen_local[n]	= cb_load(p++);
	s.cb_e_con_local[n]	= cb_load(p++);
	s.cb_e_gen_remote[n]	= cb_load(p++);
	s.cb_e_con_remote[n]	= cb_load(p++);
	s.cb_e_if_active[n]	= cb_load(p++);
	s.cb_e_if_passive[n]	= cb_load(p++);
#ifdef WITH_SIGNAL_ERRORS
	s.cb_v_orgn[n]		= cb_load(p++);
	s.cb_i_orgn[n]		= cb_load(p++);
#endif
}

/* Load State */
s.seqno_local = _seqno_local;
s.seqno_offset = seqno_offset;
s.has_seqno_offset = has_seqno_offset;

s.prev_p = prev_p;
s.e_gen = e_gen;
s.e_con = e_con;

ebm_step(dt, &i, &o, &s);

/* Save State */
_seqno_local = s.seqno_local;
seqno_offset = s.seqno_offset;
has_seqno_offset = s.has_seqno_offset;

/* Save buffers */
p = 0;

for (n = 0; n < NPHASES; n++) {
#ifdef WITH_SIGNAL_RESIDUALS
	cb_store(&s.cb_v_local[n], p++);
	cb_store(&s.cb_i_local[n], p++);
#endif
	cb_store(&s.cb_e_gen_local[n], p++);
	cb_store(&s.cb_e_con_local[n], p++);
	cb_store(&s.cb_e_gen_remote[n], p++);
	cb_store(&s.cb_e_con_remote[n], p++);
	cb_store(&s.cb_e_if_active[n], p++);
	cb_store(&s.cb_e_if_passive[n], p++);
#ifdef WITH_SIGNAL_ERRORS
	cb_store(&s.cb_v_orgn[n], p++);
	cb_store(&s.cb_i_orgn[n], p++);
#endif
}

/* Save outputs */
status			= o.status;
send_ready		= o.send_ready;
ebm_ready		= o.ebm_ready;
seqno_local		= o.seqno_local;
delay			= o.delay;

// ------------ End of CODE: Section -------------
